clear all

global numclusters 2
parallel setclusters ${numclusters}
global RNG_state 01042014 //date of file creation

global reps 50
global testing = 0
if ${testing}==1{
	set trace on
	set tracedepth 2
	global reps 10
	global file_suffix "_testing"
}

*Does: Tracks the RNG state to make parallel same as serial,
*		parses up uneven tasks, appends datasets, cleans up temps
* If doesn't work do: parallel clean, all force
program parallel_helper
	syntax , infile(string) outfile(string)
	
	global RNG_state1 = "`c(seed)'"
	local normal_reps = floor(${reps}/${numclusters})
	forval i=1/`=(${numclusters}-1)'{
		global reps`i' = `normal_reps'
		gen_bs , justrandom
		global RNG_state`=`i'+1' = "`c(seed)'"
	}
	global reps${numclusters} = `reps' - (${numclusters}-1)*`normal_reps'
	
	parallel, mata nodata keep: gen_bs , infile(`infile') outfile(`outfile')
	global pid `r(pll_id)'

	*Aggregate the estimates
	drop _all
	forval i = 1/${numclusters} {
		append using "`outfile'`i'.dta"
	}
	qui save "`outfile'", replace

	*Do after the data appending so that if one process fails, temps still around
	forval i = 1/${numclusters} {
		erase "`outfile'`i'.dta"
		erase "bs_run`i'.log"
	}

	parallel clean, event(${pid}) force

end

local outfile "bs_reps${file_suffix}"
if ${numclusters}==1{
	gen_bs, infile(auto) outfile(`outfile')
}
else{
	parallel_helper, infile(auto) outfile(`outfile')
}

use "`outfile'", clear

*Analyze the bs_results
